// Copyright (c) 2000-2012 ActiveState Software Inc.
// See the file LICENSE.txt for licensing information.

// Manage stackato app debugging parameters.

var widgets = {};
var g_obj;

function onLoad() {
    widgets.stackatoDebug = document.getElementById("stackatoDebug");
    widgets.debugHost = document.getElementById("debugHost");
    widgets.debugPort = document.getElementById("debugPort");
    g_obj = window.arguments[0];
    widgets.stackatoDebug.checked = g_obj.stackatoDebug;
    widgets.debugHost.value = g_obj.debugHost;
    widgets.debugPort.value = g_obj.debugPort;
    updateDebuggerFields(widgets.stackatoDebug);
}

function onOK() {
    g_obj.result = true;
    // Update all the values, even if the checkbox is unchecked.
    g_obj.stackatoDebug = widgets.stackatoDebug.checked;
    g_obj.debugHost = widgets.debugHost.value;
    g_obj.debugPort = widgets.debugPort.value;
    return true;
}

function onCancel() {
    g_obj.result = false;
    return true;
}

function checkFields() {
    // If the checkbox is off, or both fields are non-empty, allow 'ok'
    // Otherwise, don't.
    var enabled = (!widgets.stackatoDebug.checked
                   || (widgets.debugHost.value && widgets.debugPort.value));
    document.documentElement.getButton("accept").disabled = !enabled;
}

function updateDebuggerFields(checkbox) {
    var disabled = !checkbox.checked;
    widgets.debugHost.disabled = disabled;
    widgets.debugPort.disabled = disabled;
    checkFields();
}
